#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/03/13
#Last Modify: 2018/03/13
# Mastering Machine Learning with Python in Six Steps page 279

import pandas as pd
import pylab as plt
import numpy as np
from sklearn.cross_validation import train_test_split
#from sklearn.linear_model import LogisticRegression
#from sklearn import metrics
from sklearn.preprocessing import StandardScaler
from sklearn import tree
#from sklearn.cross_validation import cross_val_score
from sklearn.model_selection import cross_val_score
from sklearn import cross_validation

# NOTE the output is significantly different from the text
# read the data in
path = "~/projects/mastering_machine_learning_python/uci_pima_indians_diabetes/data/pima-data.csv"
df = pd.read_csv(path)
print df[:10]
X = df.ix[:,:8].values # independent variables
y = df['diabetes'].values # dependent variables
# Normalize Data
sc = StandardScaler()
sc.fit(X)
X = sc.transform(X)
# evaluate the model by splitting into train and test sets
X_train, X_test, y_train, y_test = train_test_split(X, y,test_size=0.3, random_state=2017)
# build a decision tree classifier
clf = tree.DecisionTreeClassifier(random_state=2017)
# evaluate the model using 10-fold cross-validation
train_scores = cross_val_score(clf, X_train, y_train, scoring='accuracy', cv=5)
test_scores = cross_val_score(clf, X_test, y_test, scoring='accuracy', cv=5)
print "Train Fold AUC Scores: ", train_scores
print "Train CV AUC Score: ", train_scores.mean()
print "\nTest Fold AUC Scores: ", test_scores
print "Test CV AUC Score: ", test_scores.mean()


# NOTE there is something wrong here, getting 100% accuracy on all test folds
# stratified kfold cross-validation
kfold = cross_validation.StratifiedKFold(y=y_train, n_folds=5, random_state=2017)
train_scores = []
test_scores = []
for k, (train, test) in enumerate(kfold):
  clf.fit(X_train[train], y_train[train])
  train_score = clf.score(X_train[train], y_train[train])
  train_scores.append(train_score)# score for test set
  test_score = clf.score(X_train[test], y_train[test]) #NOTE I think the error is here
  test_scores.append(test_score)
  print('Fold: %s, Class dist.: %s, Train Acc: %.3f, Test Acc: %.3f' % (k+1, np.bincount(y_train[train]), train_score, test_score))

print('\nTrain CV accuracy: %.3f' %
(np.mean(train_scores)))
print('Test CV accuracy: %.3f' % (np.mean(test_scores)))
